# apparatus: Write-up

Дано [изображение макетной платы](public/apparatus.jpg) с микроконтроллером, кнопками, светодиодами и проводами, [прошивка](public/apparatus.ino) микроконтроллера, а также [видео, как эти светодиоды загораются](public/apparatus.mp4) (по звуку понятно, что к этому приводят нажатия кнопок, которые на видео не видны).

Макетная плата — устройство для быстрой сборки электрических схем. Боковые отверстия соединены вертикально, а центральные — горизонтально по пять:

![Breadboard connections](https://os.mbed.com/media/uploads/mbedofficial/breadboardconnections.jpg)

Зная этот принцип, можно, не разбираясь в деталях схемы, понять, что вся её суть в том, что к пронумерованным входам-выходам микроконтроллера подключены 12 кнопок и 4 светодиода. Аккуратно отследив траекторию соответствующих проводов, выясним, что кнопки подключены к пинам 2, 6, 7, 9, 12, 13 и A0–A5, а светодиоды — к пинам 4, 8, 10 и 11.

Рассмотрим код прошивки. Интерес представляет функция `loop`, выполняемая контроллером в бесконечном цикле. В переменную `new_state` заносится 12-битное число, биты в котором соответствуют нажатости кнопок. Далее, если нажата ровно одна кнопка, в переменную p2 попадает её номер (кнопке A5 соответствует номер 0, A4 — 1, …, кнопке 6 — 10, кнопке 7 — 11). Переменная `reg` претерпевает побитовый XOR со значением `REG[p2]`. Дальше все светодиоды ненадолго загораются, а потом отображают значение переменной `reg` (синий светодиод отображает младший бит, красный — старший). Если кнопка была отпущена, светодиоды гаснут.

Восстановим по видео нажатия кнопок. Например, для первого нажатия `reg = 0b0111` (7). Индекс семёрки в массиве `REG` — 3, значит, `p2 = 3`, значит, была нажата кнопка, подключенная к пину A2 (размещённая на строках 51–53 макетной платы). После второго нажатия `reg = 0b1010` (10). Значит, переменная `reg` была изменена на 7 xor 10 = 13 (то есть произошло присваивание `reg = 7 xor 13`). Находим 13 в массиве `REG`, индекс — 10, значит, нажата кнопка, подключенная к пину 6 (строки 47–49 макетной платы). Аналогичным образом можно восстановить последующие нажатия.

Итак, были нажаты кнопки, соответствующие пинам A2, 6, A4, 7, 12, A4, 7, 12, 9, 6, 13, 2, A5, A2, A0, 12, 13, 9, 7, A3, A4, 6. Можно заметить, что кнопки представляют собой скошенную сетку 3×4, [как на цифровой клавиатуре телефона](public/apparatus-2cc94c1b6ec29159505d27e55513d678.jpg). При такой интерпретации нажатия образуют последовательность `84951951746*0831675294`. `8 495` в начале намекает, что это какой-то телефон (с добавочным номером).

Звонивших по этому номеру встречала злая автоответчица. Нужно было набрать в тоновом режиме (DTMF-сигналами) код после звёздочки. После каждой цифры произносился кусок флага. Города во флаге подобраны так, чтобы их названия записывались латиницей без неоднозначностей.

Флаг: **ugra\_saratov\_vladimir\_penza\_tula\_taganrog\_samara\_omsk\_kirov\_tambov**
