# Инновационные технологии: Write-up

Сайт по HTTPS, как и ожидалось, не открывается. Если открыть сайт по HTTP, то будет показано 
предложение переключиться на HTTPS.

В футере видим, что используется nginx на Ubuntu 10.04. Также, если зайти на 443 порт, но по HTTP 
(`http://legacy.ugractf.ru:443/`), то можно увидеть версию nginx — 0.7.43. И вправду какой-то 2010.

Давайте разберемся, что идет не так, и почему мы не можем подключиться. В действительности, HTTPS — 
это не просто протокол, это целое семейство протоколов HTTP over SSL/TLS.

Теперь небольшой экскурс в историю. Протокол SSL придумали в компании Netscape Communications в 1994 
году. За несколько лет появились версии 2.0 и 3.0 этого протокола, исправляющие некоторые ошибки, а 
в 1999 году появился TLS 1.0.

Никто особо не торопился переходить на TLS, но в 2014 году была обнаружена POODLE (CVE-2014-3566), 
из-за которой продолжать использовать SSL было невозможно. После этого в самые короткие сроки 
поддержка SSLv3 была выпилена из OpenSSL, всех современных браузеров и ОС.

Следовательно, можно предположить, что раз сайт был сделан в 2010, об этой уязвимости ещё не знали,
и на сервере используется именно SSL вместо TLS. Как же можно открыть такой сайт?

Во-первых, можно поставить виртуалку со старой операционной системой (Ubuntu 10.04, как на самом сервере, отлично пойдет), и просто открыть сайт. Список браузеров, поддерживающих SSLv3, можно подсмотреть в SSL Test (и заодно увидеть, почему SSLv3 использовать не стоит):

![SSL Test (ругается)](images/ssltest.png)

А ещё можно найти вот этот [ответ на StackExchange](https://security.stackexchange.com/questions/108676/need-to-access-old-forgotten-router-that-only-supports-sslv3), где рассказывается, как включить SSLv3 во многих браузерах.

Флаг: **ugra_2010_got_back_today**
